%global opt %(test -x %{_bindir}/ocamlopt && echo 1 || echo 0)
%global debug_package %{nil}

Name:            whenjobs
Version:         0.7.3
Release:         4%{?dist}
Summary:         Replacement for cron with dependencies

Group:           Development/Libraries
License:         GPLv2+
URL:             http://people.redhat.com/~rjones/whenjobs
Source0:         http://people.redhat.com/~rjones/whenjobs/files/%{name}-%{version}.tar.gz

Patch0001:       0001-Persist-variables-to-file-.whenjobs-variables.patch

ExclusiveArch:   %{ocaml_arches}

BuildRequires:   ocaml >= 3.12.0
BuildRequires:   ocaml-ocamldoc
BuildRequires:   ocaml-findlib-devel
BuildRequires:   ocaml-calendar-devel >= 2
BuildRequires:   ocaml-ocamlnet-devel >= 3
BuildRequires:   ocaml-camlp4-devel
BuildRequires:   mailx

# For building manual pages.
BuildRequires:   /usr/bin/perldoc

# Not clear what requires this, but it is needed.
BuildRequires:   pcre-devel
BuildRequires:   ocaml-pcre-devel

# Requires camlp4 and ocamlfind at runtime.
Requires:        /usr/bin/ocamlc
Requires:        ocaml-camlp4-devel
Requires:        ocaml-findlib-devel

# Requires mailx for sending email.
Requires:        mailx


%description
Whenjobs is a powerful but simple cron replacement.

Two key advantages over cron are a simpler syntax for writing rules
and a powerful dependency system that lets one job depend on variables
set when other jobs run (allowing, for example, one job to run only
when another job has finished successfully).


%prep
%setup -q

%patch0001 -p1
chmod +x tests/variables/test-persistent-variables.sh

rm lib/whenproto_aux.ml
rm lib/whenproto_aux.mli


%build
%configure
make %{?_smp_mflags}


%check
make check


%install
make DESTDIR=$RPM_BUILD_ROOT install

%if %opt
# Remove bytecode library.
rm $RPM_BUILD_ROOT%{_libdir}/whenjobs/whenlib.cma
%endif

# Strip binaries (why doesn't RPM do this?)
strip --strip-all $RPM_BUILD_ROOT%{_bindir}/whenjobs
strip --strip-all $RPM_BUILD_ROOT%{_sbindir}/whenjobsd


%files
%doc COPYING README
%{_bindir}/whenjobs
%{_sbindir}/whenjobsd
%dir %{_libdir}/whenjobs
%{_libdir}/whenjobs/*.cmi
%{_libdir}/whenjobs/pa_when.cmo
%if %opt
%{_libdir}/whenjobs/whenlib.cmxa
%else
%{_libdir}/whenjobs/whenlib.cma
%endif
%{_mandir}/man1/*.1*
%{_mandir}/man8/*.8*


%changelog
* Tue Oct 30 2012 Richard W.M. Jones <rjones@redhat.com> - 0.7.3-4
- Rebuild for OCaml 4.00.1.

* Mon Aug 20 2012 Dan Horák <dan[at]danny.cz> - 0.7.3-3
- set ExclusiveArch

* Sat Aug 18 2012 Richard W.M. Jones <rjones@redhat.com> - 0.7.3-2
- Add upstream patch for persisting variables across runs.

* Fri Jul 20 2012 Richard W.M. Jones <rjones@redhat.com> - 0.7.3-1
- Initial release (RHBZ#803089).
